<template>
  <v-dialog v-model="drawer" width="auto">
    <v-card>
      <v-card-title
        ><v-icon>mdi-exit-to-app</v-icon> Leaving the investgation</v-card-title
      >
      <v-card-text>
        You are about to leave the investigation. Are you sure ?
      </v-card-text>
      <v-card-actions class="d-flex flex-row-reverse">
        <v-btn color="error" @click="leaveInvestigation()"> Yes </v-btn>
        <v-btn color="success" @click="close()">Cancel</v-btn>
      </v-card-actions>
    </v-card>
  </v-dialog>
</template>

<script>
import { useISAStore } from "@/stores/useISAStore";

export default {
  props: {
    investigationLeaveDialog: {
      required: true,
    },
  },
  setup(props) {
    const ISAStore = useISAStore();
    const { data: session } = useSession();
    return { ISAStore, session };
  },
  data() {
    return {
      drawer: false,
      snackbarMessage: null,
      snackbarMessageType: null,
    };
  },
  emits: ["investigationLeaveDialog", "snackbarMessage"],
  watch: {
    investigationLeaveDialog(newValue) {
      this.drawer = newValue;
    },
  },
  methods: {
    close() {
      this.drawer = false;
      this.$emit("investigationLeaveDialog", false);
    },
    async leaveInvestigation() {
      await useAPIFetch(
        "/api/investigations/" +
          this.ISAStore.currentInvestigation.id +
          "/members/username:" +
          this.session.userMadbot.username +
          "/",
        {
          method: "DELETE",
        }
      ).then((res) => {
        const error = res.error.value;
        if (error) {
          this.$emit("snackbarMessage", res.error.value.data.Message);
        } else {
          this.ISAStore.fetchInvestigations()
          if (this.ISAStore.investigations.size == 0) {
            navigateTo("/investigations/first");
          } else {
            navigateTo(
              "/investigations/" + Array.from(this.ISAStore.investigations.values())[0].id
              );
            }
          this.$emit("snackbarMessage", "You have left the investigation");
        }
        this.close();
      });
    },
  },
};
</script>
